#ifndef NGHOSTCOMMON_SERVICE_NGHOSTCOMMONSERVICE_PROTECT
#define NGHOSTCOMMON_SERVICE_NGHOSTCOMMONSERVICE_PROTECT

// -----------------------------------------------
// enum NGhostCommon::Service::NGhostCommonService
// -----------------------------------------------

typedef enum NGhostCommonService
{
	NGHOST_COMMON_SERVICE_INFO,

	NGHOST_COMMON_SERVICE_STATUS_GET,
	NGHOST_COMMON_SERVICE_STATUS_POST,

	NGHOST_COMMON_SERVICE_TOKEN,

	NGHOST_COMMON_SERVICE_AUTHENTICATION_ADD,
	NGHOST_COMMON_SERVICE_AUTHENTICATION_DELETE,
	NGHOST_COMMON_SERVICE_AUTHENTICATION_GET,
	NGHOST_COMMON_SERVICE_AUTHENTICATION_UPDATE,

	NGHOST_COMMON_SERVICE_ACTION_LIST_GET,
	NGHOST_COMMON_SERVICE_ACTION_LIST_POST,
	NGHOST_COMMON_SERVICE_ACTION_LIST_PUT,
	NGHOST_COMMON_SERVICE_ACTION_LIST_PATCH,

	NGHOST_COMMON_SERVICES
} NGhostCommonService;

/**
 * Get name API
 *
 * @param serviceType
 * 		The service type
 *
 * @return the api URI
 */
const char *NGhostCommon_Service_NGhostCommonService_GetServiceURI( NGhostCommonService serviceType );

/**
 * Find service type
 *
 * @param requestedElement
 * 		The requested element
 * @param cursor
 * 		The cursor in requested element
 * @param httpRequestType
 * 		The http request type
 *
 * @return the service type
 */
NGhostCommonService NGhostCommon_Service_NGhostCommonService_FindService( const char *requestedElement,
	NU32 *cursor,
	NTypeRequeteHTTP httpRequestType );

#ifdef NGHOSTCOMMON_SERVICE_NGHOSTCOMMONSERVICE_INTERNE
__PRIVATE char NGhostCommonServiceURL[ NGHOST_COMMON_SERVICES ][ 64 ] =
{
	NDEVICE_COMMON_TYPE_GHOST_LIFECHECK,

	NDEVICE_COMMON_TYPE_GHOST_STATUS,
	NDEVICE_COMMON_TYPE_GHOST_STATUS,

	NDEVICE_COMMON_TYPE_GHOST_TOKEN_MANAGER,

	NDEVICE_COMMON_TYPE_GHOST_AUTHENTICATION,
	NDEVICE_COMMON_TYPE_GHOST_AUTHENTICATION,
	NDEVICE_COMMON_TYPE_GHOST_AUTHENTICATION,
	NDEVICE_COMMON_TYPE_GHOST_AUTHENTICATION,

	NDEVICE_COMMON_TYPE_GHOST_ACTION_SERVICE,
	NDEVICE_COMMON_TYPE_GHOST_ACTION_SERVICE,
	NDEVICE_COMMON_TYPE_GHOST_ACTION_SERVICE,
	NDEVICE_COMMON_TYPE_GHOST_ACTION_SERVICE
};

__PRIVATE NTypeRequeteHTTP NGhostCommonServiceRequestType[ NGHOST_COMMON_SERVICES ] =
{
	NTYPE_REQUETE_HTTP_GET,

	NTYPE_REQUETE_HTTP_GET,
	NTYPE_REQUETE_HTTP_POST,

	NTYPE_REQUETE_HTTP_GET,

	NTYPE_REQUETE_HTTP_POST,
	NTYPE_REQUETE_HTTP_DELETE,
	NTYPE_REQUETE_HTTP_GET,
	NTYPE_REQUETE_HTTP_PUT,

	NTYPE_REQUETE_HTTP_GET,
	NTYPE_REQUETE_HTTP_POST,
	NTYPE_REQUETE_HTTP_PUT,
	NTYPE_REQUETE_HTTP_PATCH
};
#endif // NGHOSTCOMMON_SERVICE_NGHOSTCOMMONSERVICE_INTERNE

#endif // !NGHOSTCOMMON_SERVICE_NGHOSTCOMMONSERVICE_PROTECT
